package com.mokabyte.mokabook.jmx;

import javax.management.*;
import com.sun.jdmk.comm.HtmlAdaptorServer;


/**
 * Questo esempio mostra come attivare nell'agent un adaptor HTTP e registrare contemporaneamente
 * l'MBean HelloMBean da remoto tramite il browser
 * Per far funzionare questo esempio lanciare questa classe e poi collegarsi all'indirizzo localhost:8082
 * Apparir una pagina di gestione dell'adaptor HTTP e dell'oggetto registrato
 *
 * La stampa di messaggi sulla console serve per seguire il comportamento della applicazione: sostituire con un
 * sistema di log come log4j o altro.
 */
public class Agent {

  public Agent() {
  }


  public static void main(String[] args) {
    System.out.println("Crea un Server Agent");
    MBeanServer server = MBeanServerFactory.createMBeanServer();

    ObjectName name = null;
    try {
      name = new ObjectName("example:name=hello");
      System.out.println("Registrazione nel server del managed object HelloMBean ");
      server.registerMBean(new Hello(), name);

      System.out.println("Creazione di un adaptor HTTP in ascolto sulla porta 8082");
      HtmlAdaptorServer adaptor = new HtmlAdaptorServer();
      name = new ObjectName("adaptor:protocol=HTTP");
      // registra nel server l'adaptor
      server.registerMBean(adaptor, name);
      // parte
      adaptor.start();
      System.out.println("Adaptor HTTP partito....");
    }
    catch (MalformedObjectNameException ex) {
      System.out.println("MalformedObjectNameException "+ex);
    }

    catch (NotCompliantMBeanException ex) {
      System.out.println("NotCompliantMBeanException "+ex);
    }
    catch (MBeanRegistrationException ex) {
      System.out.println("MBeanRegistrationException "+ex);
    }
    catch (InstanceAlreadyExistsException ex) {
      System.out.println("InstanceAlreadyExistsException "+ex);
    }
  }

}