package com.mokabyte.mokabook.jmx;

import java.util.Vector;


/**
 * Classe base che rappresenta un utente; contiene alcuni metodi base corrispondenti alle propriet dell'utente
 * pi alcuni metodi di business invocabili da remoto tramite il JMX Agent
 *
 * La stampa di messaggi sulla console serve per seguire il comportamento della applicazione: sostituire con un
 * sistema di log come log4j o altro.

 */

public class User implements UserMBean {

  private String ID= ""+System.currentTimeMillis();
  private String name="";
  private String address="";
  private String password=null;

  private Vector PhoneNumbers = new Vector();

  public User() {
  }

  public static void main(String[] args) {
    User user1 = new User();
  }

  // metodi di management JMX
  public void addPhoneNumber(String number){
    PhoneNumbers.addElement(number);
  }

  public void removePhoneNumber(int i){
    if (i<PhoneNumbers.size())
      PhoneNumbers.removeElementAt(i);
  }

  public String printInfo(){
    return "ID: "+ ID +"\n name: "+name+"\naddress: "+ address+"\npassword: "+password+"\nPhoneNumbers: "+PhoneNumbers;
  }

  // metodi accessori getXXX/setXXX
  public String getID() {
    return ID;
  }

  public String getName() {
    return this.name;
  }

  public void setName(String name) {
    this.name=name;
  }

  public String getAddress() {
    return this.address;
  }

  public void setAddress(String address) {
    this.address=address;
  }

  public Vector getPhoneNumbers() {
    return this.PhoneNumbers;
  }

  public void setPhoneNumbers(Vector Numbers) {
    this.PhoneNumbers = Numbers;
  }

  public String getPassword() {
    return this.password;
  }

  public void setPassword(String password) {
    this.password=password;
  }

}