package com.mokabyte.mokabook.jmx;

import javax.management.*;
import javax.management.NotificationFilter;
import javax.management.NotificationListener;
import javax.management.MBeanNotificationInfo;
import javax.naming.*;


/**
 * Estensione della classe User con funzionalit di provider di eventi
 * il metodo remove effettua il broadcast dell'evento tramite un
 * NotificationBroadcasterSupport
 *
 * La stampa di messaggi sulla console serve per seguire il comportamento della applicazione: sostituire con un
 * sistema di log come log4j o altro.
 */

public class BroadcastingUser extends User implements BroadcastingUserMBean, NotificationBroadcaster{

  private NotificationBroadcasterSupport Broadcaster = new NotificationBroadcasterSupport();
  private long NotificationSequence=0;

  public BroadcastingUser() {}

  public static void main(String[] args) {
    BroadcastingUser broadcastingUser1 = new BroadcastingUser();

  }

  public void addNotificationListener(NotificationListener notificationListener, NotificationFilter notificationFilter, Object object) {
    Broadcaster.addNotificationListener(notificationListener, notificationFilter, object);
  }

  public void removeNotificationListener(NotificationListener notificationListener) throws ListenerNotFoundException {
    Broadcaster.removeNotificationListener(notificationListener);
  }

  public MBeanNotificationInfo[] getNotificationInfo() {
    return null;
  }

  public void remove() {
    System.out.println("--- Enter BroadcastingUser.remove()");
    Notification UserNotification = new Notification("com.mokabyte.community.user.remove",this,++NotificationSequence,"L'utente "+this.getName()+"  stato rimosso");
    System.out.println("    UserNotification: "+UserNotification);
    Broadcaster.sendNotification(UserNotification);
    System.out.println("    invio notifica effettuato");
    System.out.println("--- Exit BroadcastingUser.remove()");
  }
}