package com.mokabyte.mokabook.jmx;

import javax.management.*;
import javax.management.InstanceNotFoundException;

/**
 * Un ascoltatore di eventi generici per la classe User.
 *
 * La stampa di messaggi sulla console serve per seguire il comportamento della applicazione: sostituire con un
 * sistema di log come log4j o altro.
 */
public class UserListener implements NotificationListener {

  MBeanServer Server = null;

  public UserListener(MBeanServer server) {
    Server= server;
  }



  public void handleNotification(Notification notification, Object handback) {
    System.out.println("--- Enter handleNotification()");
    String NotificationType = notification.getType();

    System.out.println("    Ricevuto un evento con NotificationType: "+NotificationType);
    System.out.println("    Messaggio associato all'evento: "+notification.getMessage());
    try {
      Server.unregisterMBean( (ObjectName) handback);
    }
    catch (MBeanRegistrationException ex) {
      System.out.println("MBeanRegistrationException: "+ex);
    }
    catch (InstanceNotFoundException ex) {
      System.out.println("InstanceNotFoundException "+ex);
    }
    System.out.println("--- Exit handleNotification()");
  }

}